unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    procedure ProcMessageApplic (var Msg: TMsg; var Handled: Boolean);
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

const
  idItem1Menu = 100;// ce n sert d'identificateur  un item de menu
  idItem2Menu = 101;// idem pour un autre item

procedure TForm1.FormCreate(Sender: TObject);
begin
  // GetSystemMenu (Application.Handle, FALSE) donne le handle du menu pop de l'application dans la barre des taches
  // appendMenu ajoute un item dans le menu
  AppendMenu (GetSystemMenu (Application.Handle, FALSE),MFT_SEPARATOR, 0, ''); // ajoute un sparateur
  AppendMenu (GetSystemMenu (Application.Handle, FALSE),MFT_STRING, idItem1Menu, '&Hello word...'); // ajoute un item dans le menu
  AppendMenu (GetSystemMenu (Application.Handle, FALSE),MFT_STRING, idItem2Menu, '&Bonjour monde...');

  Application.OnMessage := ProcMessageApplic;// pour rediriger l'vnement OnMessage de l'application vers notre procdure ProcMessageApplic
end;

procedure TForm1.ProcMessageApplic (var Msg: TMsg; var Handled: Boolean);
// Dans la procdure TForm1.FormCreate, nous avons dclar que c'est cette procdure qui sera appel lors d'un vnement OnMessage de l'application
// Cette procdure est donc dclench pour chaque message destin  notre application (voir le tutorial sur les messages)
begin
// Lorsque l'utilisateur clique sur un item d'un menu, cela dclenche un message WM_SYSCOMMAND
// L'item sur lequel il a cliqu est contenu dans Msg/wParam
  if (Msg.Message = WM_SYSCOMMAND) and (Msg.wParam = idItem1Menu) then  // il a cliqu sur l'item idItem1Menu
  begin
    ShowMessage ('Hello Word !');
    Handled := True;
  end;
  if (Msg.Message = WM_SYSCOMMAND) and (Msg.wParam = idItem2Menu) then
  begin
    ShowMessage ('Bonjour monde !');
    Handled := True;
  end;
end;


{================================================================================}
{ les lignes de codes ci-dessous ne sont utiles que si l'on veut grer le cochage}
{ou l'inactivage d'un item                                                       }
{================================================================================}

procedure TForm1.Button1Click(Sender: TObject);
// l' exemple ci_dessous permet de voir comment on gre le cochage des items
var etat:UINT;  //=longWord
begin
// GetMenuState permet de rcuprer l'tat d'un item de menu
  Etat:=GetMenuState (  GetSystemMenu(Application.Handle, FALSE),
                        idItem1Menu,
                        MF_BYCOMMAND);
  if (Etat and MFS_CHECKED)=MFS_CHECKED then // ce test permet de reconnaitre que l'item est coch
  begin
      CheckMenuItem(GetSystemMenu (Application.Handle, FALSE),idItem1Menu,MFS_UNCHECKED or MF_BYCOMMAND);// rends l'item non coch
      Button1.caption:= 'Cocher l''item Hello Word';
  end
  else
  begin
    CheckMenuItem(GetSystemMenu (Application.Handle, FALSE),idItem1Menu,MFS_CHECKED or MF_BYCOMMAND);// rends l'item coch
    Button1.caption:= 'Dcocher l''item Hello Word';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
// cet exemple permet de voir comment on gre le fait de rendre actif ou non un item du menu
var etat:UINT;  //=longWord
begin
// GetMenuState permet de rcuprer l'tat d'un item de menu
 Etat:=GetMenuState ( GetSystemMenu(Application.Handle, FALSE),
                        idItem1Menu,
                        MF_BYCOMMAND);
  if (Etat and MF_GRAYED)=MF_GRAYED then // ce test permet de reconnaitre si l'item est inactif
  begin
    EnableMenuItem(GetSystemMenu (Application.Handle, FALSE),idItem1Menu, MF_ENABLED or MF_BYCOMMAND); //rends l'item actif
    Button2.caption:= 'Rendre inactif l''item Hello Word';
  end
  else
  begin
    EnableMenuItem(GetSystemMenu (Application.Handle, FALSE),idItem1Menu, MF_GRAYED or MF_BYCOMMAND); //rends l'item inactif
    Button2.caption:= 'Rendre actif l''item Hello Word';
  end;
end;

end.


